import math
import random
from .lua_globals import argumentValidation

def __random(args):
    if len(args) == 0:
        return random.random()
    elif len(args) == 1:
        return random.randint(1, args[0])
    else:
        return random.randint(args[0], args[1])
        
maths = {
    'abs': lambda *args: abs(argumentValidation(args)[0]),
    'mod': lambda *args: argumentValidation(args)[0] % argumentValidation(args)[1],
    'floor': lambda *args: math.floor(argumentValidation(args)[0]),
    'ceil': lambda *args: math.ceil(argumentValidation(args)[0]),
    'min': lambda *args: min(argumentValidation(args)),
    'max': lambda *args: max(argumentValidation(args)),
    'sqrt': lambda *args: math.sqrt(argumentValidation(args)[0]),
    'pow': lambda *args: argumentValidation(args)[0] ** argumentValidation(args)[1],
    'exp': lambda *args: math.exp(argumentValidation(args)[0]),
    'log': lambda *args: math.log(argumentValidation(args)[0]),
    'log10': lambda *args: math.log10(argumentValidation(args)[0]),
    'deg': lambda *args: math.degrees(argumentValidation(args)[0]),
    'rad': lambda *args: math.radians(argumentValidation(args)[0]),
    'pi': math.pi,
    'sin': lambda *args: math.sin(argumentValidation(args)[0]),
    'cos': lambda *args: math.cos(argumentValidation(args)[0]),
    'tan': lambda *args: math.tan(argumentValidation(args)[0]),
    'asin': lambda *args: math.asin(argumentValidation(args)[0]),
    'acos': lambda *args: math.acos(argumentValidation(args)[0]),
    'atan': lambda *args: math.atan(argumentValidation(args)[0]),
    'atan2': lambda *args: math.atan2(argumentValidation(args)[0], argumentValidation(args)[1]),
    'frexp': lambda *args: math.frexp(argumentValidation(args)[0]),
    'ldexp': lambda *args: math.ldexp(argumentValidation(args)[0], argumentValidation(args)[1]),
    'random': lambda *args: __random(argumentValidation(args)),
    'randomseed': lambda *args: random.seed(argumentValidation(args)[0])
}